package agents; 



import sim.engine.*;
import sim.util.*;
import tools.Tools;
import org.apache.commons.math3.stat.descriptive.DescriptiveStatistics;



public class Data {
	
	
	/*The String array fileheaders should have all the variables to be collected, in the order 
	 * They are added to the Bag data in the getData method. */
	
	public String[] fileheaders = null;	
	public Bag headerBag = null;
	public Bag dataBag = null; 
	


	
	public Data(){

	}

	
	
	/**
	 * Calculate stats for charting.
	 */
	public void calcStats(final SimState state) {
        final AgentsSimulation as = (AgentsSimulation)state;
        
        double[] infected = as.freqInfected();
        try { 
            as.stepInfected_0A = infected[0];
            as.stepInfected_0B = infected[1];
            as.stepInfected_1A = infected[2];
            as.stepInfected_1B = infected[3];
        }
        catch (ArithmeticException e){}
        

	}
        
	/**
	 * Returns a Bag with all the values desired by the user for a data file.
	 * The method to make the header file is in AgentsSimulation.java
	 */
	public  Bag getData(final SimState state, int runCount){
		final AgentsSimulation as = (AgentsSimulation)state;  // gets the state of the simulation
		dataBag = new Bag(); 
		
		//First, add the things the state-level parameters
		dataBag.add((double)(runCount)); 
		//global run parameters
		dataBag.add((double)as.numPatches);
		dataBag.add((double)as.numAgentsPerPatch);
		dataBag.add((double)as.maxPatchSkew);
		dataBag.add((double)as.numEarlyAdopters1);
		double xx =  as.earlyAdoptersInOnePatch ? 1 : 0;
		dataBag.add((double)xx); //early adopters in one patch?
		dataBag.add((double)as.startPatch);
		//dynamic parameters
		dataBag.add((double)as.interactionRate);
		dataBag.add((double)as.probSamePatch);
		dataBag.add((double)as.observationSampleSize);
		double yy =  as.outPatchNeighbors ? 1 : 0;
		dataBag.add((double)yy); //are out-group interactions local? Or random?
		dataBag.add((double)as.lambda);
		dataBag.add((double)as.ingroupBias);
		dataBag.add((double)as.ingroupRateOfIncrease);
		double zz =  as.useMemory ? 1 : 0;
		dataBag.add((double)zz); //use memory?
		//dependent variables
		dataBag.add((double)((AgentsSimulation)state).schedule.getSteps());//Time of the data collection
		double[] freqInfected = as.freqInfected();
		dataBag.add((double)freqInfected[0]); //freq type 0 adopt product A
		dataBag.add((double)freqInfected[2]); //freq type 1 adopt product A
		double[] maxFreqInfected = as.maxFreqInfected();
		dataBag.add((double)maxFreqInfected[0]); //max freq type 0 adopt product A
		dataBag.add((double)maxFreqInfected[2]); //max freq type 1 adopt product A
		double adopt = (freqInfected[0] + freqInfected[2])/2;
		dataBag.add(adopt); 	//total frequency of adoption
		double[] pol = as.polarization(); 
		dataBag.add(pol[0]); //global polarization
		dataBag.add(pol[1]); //local polarization
		
		return dataBag;
	}

	
    
    
    
    
}//end class







